package abp.usage.dist;
import ma.sim.FixDelay;
import abp.ABPMessage;
import abp.ABPSender;

component DelayedSender<T>[int timeout, int delay] {
  
  port 
    in T message,
    in Boolean ack,
    out ABPMessage<T> abpMessage;
    
    component ABPSender<T>(timeout);
    component FixDelay<Boolean>(delay);
    
    connect ack -> fixDelay.portIn;
    connect fixDelay.portOut -> aBPSender.ack;
    
    connect message -> aBPSender.message;
    
    connect aBPSender.abpMessage -> abpMessage;

}
